(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@rjsf/core'), require('react/jsx-runtime'), require('@rjsf/utils'), require('react-bootstrap/Button'), require('@react-icons/all-files/bs/BsPlus'), require('react-bootstrap/Row'), require('react-bootstrap/Col'), require('react-bootstrap/Container'), require('react-bootstrap/Form'), require('react-bootstrap/Card'), require('react-bootstrap/ListGroup'), require('@react-icons/all-files/io/IoIosCopy'), require('@react-icons/all-files/io/IoIosRemove'), require('@react-icons/all-files/ai/AiOutlineArrowUp'), require('@react-icons/all-files/ai/AiOutlineArrowDown'), require('react-bootstrap/FormControl'), require('react-bootstrap/InputGroup')) :
  typeof define === 'function' && define.amd ? define(['exports', '@rjsf/core', 'react/jsx-runtime', '@rjsf/utils', 'react-bootstrap/Button', '@react-icons/all-files/bs/BsPlus', 'react-bootstrap/Row', 'react-bootstrap/Col', 'react-bootstrap/Container', 'react-bootstrap/Form', 'react-bootstrap/Card', 'react-bootstrap/ListGroup', '@react-icons/all-files/io/IoIosCopy', '@react-icons/all-files/io/IoIosRemove', '@react-icons/all-files/ai/AiOutlineArrowUp', '@react-icons/all-files/ai/AiOutlineArrowDown', 'react-bootstrap/FormControl', 'react-bootstrap/InputGroup'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["@rjsf/bootstrap-4"] = {}, global.core, global.jsxRuntime, global.utils, global.Button, global.BsPlus, global.Row, global.Col, global.Container, global.Form$1, global.Card, global.ListGroup, global.IoIosCopy, global.IoIosRemove, global.AiOutlineArrowUp, global.AiOutlineArrowDown, global.FormControl, global.InputGroup));
})(this, (function (exports, core, jsxRuntime, utils, Button, BsPlus, Row, Col, Container, Form$1, Card, ListGroup, IoIosCopy, IoIosRemove, AiOutlineArrowUp, AiOutlineArrowDown, FormControl, InputGroup) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var Button__default = /*#__PURE__*/_interopDefaultLegacy(Button);
  var Row__default = /*#__PURE__*/_interopDefaultLegacy(Row);
  var Col__default = /*#__PURE__*/_interopDefaultLegacy(Col);
  var Container__default = /*#__PURE__*/_interopDefaultLegacy(Container);
  var Form__default = /*#__PURE__*/_interopDefaultLegacy(Form$1);
  var Card__default = /*#__PURE__*/_interopDefaultLegacy(Card);
  var ListGroup__default = /*#__PURE__*/_interopDefaultLegacy(ListGroup);
  var FormControl__default = /*#__PURE__*/_interopDefaultLegacy(FormControl);
  var InputGroup__default = /*#__PURE__*/_interopDefaultLegacy(InputGroup);

  function AddButton({
    uiSchema,
    registry,
    ...props
  }) {
    const {
      translateString
    } = registry;
    return jsxRuntime.jsx(Button__default["default"], {
      ...props,
      style: {
        width: '100%'
      },
      className: `ml-1 ${props.className}`,
      title: translateString(utils.TranslatableString.AddItemButton),
      children: jsxRuntime.jsx(BsPlus.BsPlus, {})
    });
  }

  function ArrayFieldItemTemplate(props) {
    const {
      children,
      disabled,
      hasToolbar,
      hasCopy,
      hasMoveDown,
      hasMoveUp,
      hasRemove,
      index,
      onCopyIndexClick,
      onDropIndexClick,
      onReorderClick,
      readonly,
      registry,
      uiSchema
    } = props;
    const {
      CopyButton,
      MoveDownButton,
      MoveUpButton,
      RemoveButton
    } = registry.templates.ButtonTemplates;
    const btnStyle = {
      flex: 1,
      paddingLeft: 6,
      paddingRight: 6,
      fontWeight: 'bold'
    };
    return jsxRuntime.jsx("div", {
      children: jsxRuntime.jsxs(Row__default["default"], {
        className: 'mb-2  d-flex align-items-center',
        children: [jsxRuntime.jsx(Col__default["default"], {
          xs: '9',
          lg: '9',
          children: children
        }), jsxRuntime.jsx(Col__default["default"], {
          xs: '3',
          lg: '3',
          className: 'py-4',
          children: hasToolbar && jsxRuntime.jsxs("div", {
            className: 'd-flex flex-row',
            children: [(hasMoveUp || hasMoveDown) && jsxRuntime.jsx("div", {
              className: 'm-0 p-0',
              children: jsxRuntime.jsx(MoveUpButton, {
                className: 'array-item-move-up',
                style: btnStyle,
                disabled: disabled || readonly || !hasMoveUp,
                onClick: onReorderClick(index, index - 1),
                uiSchema: uiSchema,
                registry: registry
              })
            }), (hasMoveUp || hasMoveDown) && jsxRuntime.jsx("div", {
              className: 'm-0 p-0',
              children: jsxRuntime.jsx(MoveDownButton, {
                style: btnStyle,
                disabled: disabled || readonly || !hasMoveDown,
                onClick: onReorderClick(index, index + 1),
                uiSchema: uiSchema,
                registry: registry
              })
            }), hasCopy && jsxRuntime.jsx("div", {
              className: 'm-0 p-0',
              children: jsxRuntime.jsx(CopyButton, {
                style: btnStyle,
                disabled: disabled || readonly,
                onClick: onCopyIndexClick(index),
                uiSchema: uiSchema,
                registry: registry
              })
            }), hasRemove && jsxRuntime.jsx("div", {
              className: 'm-0 p-0',
              children: jsxRuntime.jsx(RemoveButton, {
                style: btnStyle,
                disabled: disabled || readonly,
                onClick: onDropIndexClick(index),
                uiSchema: uiSchema,
                registry: registry
              })
            })]
          })
        })]
      })
    });
  }

  function ArrayFieldTemplate(props) {
    const {
      canAdd,
      disabled,
      idSchema,
      uiSchema,
      items,
      onAddClick,
      readonly,
      registry,
      required,
      schema,
      title
    } = props;
    const uiOptions = utils.getUiOptions(uiSchema);
    const ArrayFieldDescriptionTemplate = utils.getTemplate('ArrayFieldDescriptionTemplate', registry, uiOptions);
    const ArrayFieldItemTemplate = utils.getTemplate('ArrayFieldItemTemplate', registry, uiOptions);
    const ArrayFieldTitleTemplate = utils.getTemplate('ArrayFieldTitleTemplate', registry, uiOptions);
    // Button templates are not overridden in the uiSchema
    const {
      ButtonTemplates: {
        AddButton
      }
    } = registry.templates;
    return jsxRuntime.jsx("div", {
      children: jsxRuntime.jsx(Row__default["default"], {
        className: 'p-0 m-0',
        children: jsxRuntime.jsxs(Col__default["default"], {
          className: 'p-0 m-0',
          children: [jsxRuntime.jsx(ArrayFieldTitleTemplate, {
            idSchema: idSchema,
            title: uiOptions.title || title,
            schema: schema,
            uiSchema: uiSchema,
            required: required,
            registry: registry
          }), jsxRuntime.jsx(ArrayFieldDescriptionTemplate, {
            idSchema: idSchema,
            description: uiOptions.description || schema.description,
            schema: schema,
            uiSchema: uiSchema,
            registry: registry
          }), jsxRuntime.jsxs(Container__default["default"], {
            fluid: true,
            className: 'p-0 m-0',
            children: [items && items.map(({
              key,
              ...itemProps
            }) => jsxRuntime.jsx(ArrayFieldItemTemplate, {
              ...itemProps
            }, key)), canAdd && jsxRuntime.jsx(Container__default["default"], {
              className: '',
              children: jsxRuntime.jsxs(Row__default["default"], {
                className: 'mt-2',
                children: [jsxRuntime.jsx(Col__default["default"], {
                  xs: 9
                }), jsxRuntime.jsx(Col__default["default"], {
                  xs: 3,
                  className: 'py-4 col-lg-3 col-3',
                  children: jsxRuntime.jsx(AddButton, {
                    className: 'array-item-add',
                    onClick: onAddClick,
                    disabled: disabled || readonly,
                    uiSchema: uiSchema,
                    registry: registry
                  })
                })]
              })
            })]
          }, `array-item-list-${idSchema.$id}`)]
        })
      })
    });
  }

  function BaseInputTemplate({
    id,
    placeholder,
    required,
    readonly,
    disabled,
    type,
    value,
    onChange,
    onChangeOverride,
    onBlur,
    onFocus,
    autofocus,
    options,
    schema,
    rawErrors = [],
    children,
    extraProps
  }) {
    const inputProps = {
      ...extraProps,
      ...utils.getInputProps(schema, type, options)
    };
    const _onChange = ({
      target: {
        value
      }
    }) => onChange(value === '' ? options.emptyValue : value);
    const _onBlur = ({
      target: {
        value
      }
    }) => onBlur(id, value);
    const _onFocus = ({
      target: {
        value
      }
    }) => onFocus(id, value);
    // const classNames = [rawErrors.length > 0 ? "is-invalid" : "", type === 'file' ? 'custom-file-label': ""]
    return jsxRuntime.jsxs(jsxRuntime.Fragment, {
      children: [jsxRuntime.jsx(Form__default["default"].Control, {
        id: id,
        name: id,
        placeholder: placeholder,
        autoFocus: autofocus,
        required: required,
        disabled: disabled,
        readOnly: readonly,
        className: rawErrors.length > 0 ? 'is-invalid' : '',
        list: schema.examples ? utils.examplesId(id) : undefined,
        ...inputProps,
        value: value || value === 0 ? value : '',
        onChange: onChangeOverride || _onChange,
        onBlur: _onBlur,
        onFocus: _onFocus,
        "aria-describedby": utils.ariaDescribedByIds(id, !!schema.examples)
      }), children, Array.isArray(schema.examples) ? jsxRuntime.jsx("datalist", {
        id: utils.examplesId(id),
        children: schema.examples.concat(schema.default && !schema.examples.includes(schema.default) ? [schema.default] : []).map(example => {
          return jsxRuntime.jsx("option", {
            value: example
          }, example);
        })
      }) : null]
    });
  }

  function DescriptionField({
    id,
    description
  }) {
    if (description) {
      return jsxRuntime.jsx("div", {
        children: jsxRuntime.jsx("div", {
          id: id,
          className: 'mb-3',
          children: description
        })
      });
    }
    return null;
  }

  function ErrorList({
    errors,
    registry
  }) {
    const {
      translateString
    } = registry;
    return jsxRuntime.jsxs(Card__default["default"], {
      border: 'danger',
      className: 'mb-4',
      children: [jsxRuntime.jsx(Card__default["default"].Header, {
        className: 'alert-danger',
        children: translateString(utils.TranslatableString.ErrorsLabel)
      }), jsxRuntime.jsx(Card__default["default"].Body, {
        className: 'p-0',
        children: jsxRuntime.jsx(ListGroup__default["default"], {
          children: errors.map((error, i) => {
            return jsxRuntime.jsx(ListGroup__default["default"].Item, {
              className: 'border-0',
              children: jsxRuntime.jsx("span", {
                children: error.stack
              })
            }, i);
          })
        })
      })]
    });
  }

  function IconButton(props) {
    const {
      icon,
      iconType,
      className,
      uiSchema,
      registry,
      ...otherProps
    } = props;
    return jsxRuntime.jsx(Button__default["default"], {
      block: iconType === 'block',
      ...otherProps,
      variant: props.variant || 'light',
      size: 'sm',
      children: icon
    });
  }
  function CopyButton(props) {
    const {
      registry: {
        translateString
      }
    } = props;
    return jsxRuntime.jsx(IconButton, {
      title: translateString(utils.TranslatableString.CopyButton),
      ...props,
      icon: jsxRuntime.jsx(IoIosCopy.IoIosCopy, {})
    });
  }
  function MoveDownButton(props) {
    const {
      registry: {
        translateString
      }
    } = props;
    return jsxRuntime.jsx(IconButton, {
      title: translateString(utils.TranslatableString.MoveDownButton),
      ...props,
      icon: jsxRuntime.jsx(AiOutlineArrowDown.AiOutlineArrowDown, {})
    });
  }
  function MoveUpButton(props) {
    const {
      registry: {
        translateString
      }
    } = props;
    return jsxRuntime.jsx(IconButton, {
      title: translateString(utils.TranslatableString.MoveUpButton),
      ...props,
      icon: jsxRuntime.jsx(AiOutlineArrowUp.AiOutlineArrowUp, {})
    });
  }
  function RemoveButton(props) {
    const {
      registry: {
        translateString
      }
    } = props;
    return jsxRuntime.jsx(IconButton, {
      title: translateString(utils.TranslatableString.RemoveButton),
      ...props,
      variant: 'danger',
      icon: jsxRuntime.jsx(IoIosRemove.IoIosRemove, {})
    });
  }

  /** The `FieldErrorTemplate` component renders the errors local to the particular field
   *
   * @param props - The `FieldErrorProps` for the errors being rendered
   */
  function FieldErrorTemplate(props) {
    const {
      errors = [],
      idSchema
    } = props;
    if (errors.length === 0) {
      return null;
    }
    const id = utils.errorId(idSchema);
    return jsxRuntime.jsx(ListGroup__default["default"], {
      as: 'ul',
      id: id,
      children: errors.map((error, i) => {
        return jsxRuntime.jsx(ListGroup__default["default"].Item, {
          as: 'li',
          className: 'border-0 m-0 p-0',
          children: jsxRuntime.jsx("small", {
            className: 'm-0 text-danger',
            children: error
          })
        }, i);
      })
    });
  }

  /** The `FieldHelpTemplate` component renders any help desired for a field
   *
   * @param props - The `FieldHelpProps` to be rendered
   */
  function FieldHelpTemplate(props) {
    const {
      idSchema,
      help,
      hasErrors
    } = props;
    if (!help) {
      return null;
    }
    const id = utils.helpId(idSchema);
    return jsxRuntime.jsx(Form__default["default"].Text, {
      className: hasErrors ? 'text-danger' : 'text-muted',
      id: id,
      children: help
    });
  }

  function FieldTemplate({
    id,
    children,
    displayLabel,
    rawErrors = [],
    errors,
    help,
    description,
    rawDescription,
    classNames,
    style,
    disabled,
    label,
    hidden,
    onDropPropertyClick,
    onKeyChange,
    readonly,
    required,
    schema,
    uiSchema,
    registry
  }) {
    const uiOptions = utils.getUiOptions(uiSchema);
    const WrapIfAdditionalTemplate = utils.getTemplate('WrapIfAdditionalTemplate', registry, uiOptions);
    if (hidden) {
      return jsxRuntime.jsx("div", {
        className: 'hidden',
        children: children
      });
    }
    return jsxRuntime.jsx(WrapIfAdditionalTemplate, {
      classNames: classNames,
      style: style,
      disabled: disabled,
      id: id,
      label: label,
      onDropPropertyClick: onDropPropertyClick,
      onKeyChange: onKeyChange,
      readonly: readonly,
      required: required,
      schema: schema,
      uiSchema: uiSchema,
      registry: registry,
      children: jsxRuntime.jsxs(Form__default["default"].Group, {
        children: [displayLabel && jsxRuntime.jsxs(Form__default["default"].Label, {
          htmlFor: id,
          className: rawErrors.length > 0 ? 'text-danger' : '',
          children: [label, required ? '*' : null]
        }), children, displayLabel && rawDescription && jsxRuntime.jsx(Form__default["default"].Text, {
          className: rawErrors.length > 0 ? 'text-danger' : 'text-muted',
          children: description
        }), errors, help]
      })
    });
  }

  function ObjectFieldTemplate({
    description,
    title,
    properties,
    required,
    uiSchema,
    idSchema,
    schema,
    formData,
    onAddClick,
    disabled,
    readonly,
    registry
  }) {
    const uiOptions = utils.getUiOptions(uiSchema);
    const TitleFieldTemplate = utils.getTemplate('TitleFieldTemplate', registry, uiOptions);
    const DescriptionFieldTemplate = utils.getTemplate('DescriptionFieldTemplate', registry, uiOptions);
    // Button templates are not overridden in the uiSchema
    const {
      ButtonTemplates: {
        AddButton
      }
    } = registry.templates;
    return jsxRuntime.jsxs(jsxRuntime.Fragment, {
      children: [title && jsxRuntime.jsx(TitleFieldTemplate, {
        id: utils.titleId(idSchema),
        title: title,
        required: required,
        schema: schema,
        uiSchema: uiSchema,
        registry: registry
      }), description && jsxRuntime.jsx(DescriptionFieldTemplate, {
        id: utils.descriptionId(idSchema),
        description: description,
        schema: schema,
        uiSchema: uiSchema,
        registry: registry
      }), jsxRuntime.jsxs(Container__default["default"], {
        fluid: true,
        className: 'p-0',
        children: [properties.map((element, index) => jsxRuntime.jsx(Row__default["default"], {
          style: {
            marginBottom: '10px'
          },
          className: element.hidden ? 'd-none' : undefined,
          children: jsxRuntime.jsxs(Col__default["default"], {
            xs: 12,
            children: [" ", element.content]
          })
        }, index)), utils.canExpand(schema, uiSchema, formData) ? jsxRuntime.jsx(Row__default["default"], {
          children: jsxRuntime.jsx(Col__default["default"], {
            xs: {
              offset: 9,
              span: 3
            },
            className: 'py-4',
            children: jsxRuntime.jsx(AddButton, {
              onClick: onAddClick(schema),
              disabled: disabled || readonly,
              className: 'object-property-expand',
              uiSchema: uiSchema,
              registry: registry
            })
          })
        }) : null]
      })]
    });
  }

  function SubmitButton(props) {
    const {
      submitText,
      norender,
      props: submitButtonProps
    } = utils.getSubmitButtonOptions(props.uiSchema);
    if (norender) {
      return null;
    }
    return jsxRuntime.jsx("div", {
      children: jsxRuntime.jsx(Button__default["default"], {
        variant: 'primary',
        type: 'submit',
        ...submitButtonProps,
        children: submitText
      })
    });
  }

  function TitleField({
    id,
    title,
    uiSchema
  }) {
    const uiOptions = utils.getUiOptions(uiSchema);
    return jsxRuntime.jsxs("div", {
      id: id,
      className: 'my-1',
      children: [jsxRuntime.jsx("h5", {
        children: uiOptions.title || title
      }), jsxRuntime.jsx("hr", {
        className: 'border-0 bg-secondary',
        style: {
          height: '1px'
        }
      })]
    });
  }

  function WrapIfAdditionalTemplate({
    classNames,
    style,
    children,
    disabled,
    id,
    label,
    onDropPropertyClick,
    onKeyChange,
    readonly,
    required,
    schema,
    uiSchema,
    registry
  }) {
    const {
      templates,
      translateString
    } = registry;
    // Button templates are not overridden in the uiSchema
    const {
      RemoveButton
    } = templates.ButtonTemplates;
    const keyLabel = translateString(utils.TranslatableString.KeyLabel, [label]);
    const additional = (utils.ADDITIONAL_PROPERTY_FLAG in schema);
    if (!additional) {
      return jsxRuntime.jsx("div", {
        className: classNames,
        style: style,
        children: children
      });
    }
    const handleBlur = ({
      target
    }) => onKeyChange(target.value);
    const keyId = `${id}-key`;
    return jsxRuntime.jsxs(Row__default["default"], {
      className: classNames,
      style: style,
      children: [jsxRuntime.jsx(Col__default["default"], {
        xs: 5,
        children: jsxRuntime.jsxs(Form__default["default"].Group, {
          children: [jsxRuntime.jsx(Form__default["default"].Label, {
            htmlFor: keyId,
            children: keyLabel
          }), jsxRuntime.jsx(Form__default["default"].Control, {
            required: required,
            defaultValue: label,
            disabled: disabled || readonly,
            id: keyId,
            name: keyId,
            onBlur: !readonly ? handleBlur : undefined,
            type: 'text'
          })]
        })
      }), jsxRuntime.jsx(Col__default["default"], {
        xs: 5,
        children: children
      }), jsxRuntime.jsx(Col__default["default"], {
        xs: 2,
        className: 'py-4',
        children: jsxRuntime.jsx(RemoveButton, {
          iconType: 'block',
          className: 'w-100',
          disabled: disabled || readonly,
          onClick: onDropPropertyClick(label),
          uiSchema: uiSchema,
          registry: registry
        })
      })]
    }, keyId);
  }

  function generateTemplates() {
    return {
      ArrayFieldItemTemplate,
      ArrayFieldTemplate,
      BaseInputTemplate,
      ButtonTemplates: {
        AddButton,
        CopyButton,
        MoveDownButton,
        MoveUpButton,
        RemoveButton,
        SubmitButton
      },
      DescriptionFieldTemplate: DescriptionField,
      ErrorListTemplate: ErrorList,
      FieldErrorTemplate,
      FieldHelpTemplate,
      FieldTemplate,
      ObjectFieldTemplate,
      TitleFieldTemplate: TitleField,
      WrapIfAdditionalTemplate
    };
  }
  var Templates = /*#__PURE__*/generateTemplates();

  function CheckboxWidget(props) {
    const {
      id,
      value,
      disabled,
      readonly,
      label,
      hideLabel,
      schema,
      autofocus,
      options,
      onChange,
      onBlur,
      onFocus,
      registry,
      uiSchema
    } = props;
    // Because an unchecked checkbox will cause html5 validation to fail, only add
    // the "required" attribute if the field value must be "true", due to the
    // "const" or "enum" keywords
    const required = utils.schemaRequiresTrueValue(schema);
    const DescriptionFieldTemplate = utils.getTemplate('DescriptionFieldTemplate', registry, options);
    const _onChange = ({
      target: {
        checked
      }
    }) => onChange(checked);
    const _onBlur = ({
      target: {
        checked
      }
    }) => onBlur(id, checked);
    const _onFocus = ({
      target: {
        checked
      }
    }) => onFocus(id, checked);
    const description = options.description || schema.description;
    return jsxRuntime.jsxs(Form__default["default"].Group, {
      className: `checkbox ${disabled || readonly ? 'disabled' : ''}`,
      "aria-describedby": utils.ariaDescribedByIds(id),
      children: [!hideLabel && !!description && jsxRuntime.jsx(DescriptionFieldTemplate, {
        id: utils.descriptionId(id),
        description: description,
        schema: schema,
        uiSchema: uiSchema,
        registry: registry
      }), jsxRuntime.jsx(Form__default["default"].Check, {
        id: id,
        name: id,
        label: utils.labelValue(label, hideLabel || !label),
        checked: typeof value === 'undefined' ? false : value,
        required: required,
        disabled: disabled || readonly,
        autoFocus: autofocus,
        onChange: _onChange,
        type: 'checkbox',
        onBlur: _onBlur,
        onFocus: _onFocus
      })]
    });
  }

  function CheckboxesWidget({
    id,
    disabled,
    options,
    value,
    autofocus,
    readonly,
    required,
    onChange,
    onBlur,
    onFocus
  }) {
    const {
      enumOptions,
      enumDisabled,
      inline,
      emptyValue
    } = options;
    const checkboxesValues = Array.isArray(value) ? value : [value];
    const _onChange = index => ({
      target: {
        checked
      }
    }) => {
      if (checked) {
        onChange(utils.enumOptionsSelectValue(index, checkboxesValues, enumOptions));
      } else {
        onChange(utils.enumOptionsDeselectValue(index, checkboxesValues, enumOptions));
      }
    };
    const _onBlur = ({
      target: {
        value
      }
    }) => onBlur(id, utils.enumOptionsValueForIndex(value, enumOptions, emptyValue));
    const _onFocus = ({
      target: {
        value
      }
    }) => onFocus(id, utils.enumOptionsValueForIndex(value, enumOptions, emptyValue));
    return jsxRuntime.jsx(Form__default["default"].Group, {
      children: Array.isArray(enumOptions) && enumOptions.map((option, index) => {
        const checked = utils.enumOptionsIsSelected(option.value, checkboxesValues);
        const itemDisabled = Array.isArray(enumDisabled) && enumDisabled.indexOf(option.value) !== -1;
        return jsxRuntime.jsx(Form__default["default"].Check, {
          inline: inline,
          custom: true,
          required: required,
          checked: checked,
          className: 'bg-transparent border-0',
          type: 'checkbox',
          id: utils.optionId(id, index),
          name: id,
          label: option.label,
          autoFocus: autofocus && index === 0,
          onChange: _onChange(index),
          onBlur: _onBlur,
          onFocus: _onFocus,
          disabled: disabled || itemDisabled || readonly,
          "aria-describedby": utils.ariaDescribedByIds(id)
        }, option.value);
      })
    });
  }

  function RadioWidget({
    id,
    options,
    value,
    required,
    disabled,
    readonly,
    onChange,
    onBlur,
    onFocus
  }) {
    const {
      enumOptions,
      enumDisabled,
      emptyValue
    } = options;
    const _onChange = ({
      target: {
        value
      }
    }) => onChange(utils.enumOptionsValueForIndex(value, enumOptions, emptyValue));
    const _onBlur = ({
      target: {
        value
      }
    }) => onBlur(id, utils.enumOptionsValueForIndex(value, enumOptions, emptyValue));
    const _onFocus = ({
      target: {
        value
      }
    }) => onFocus(id, utils.enumOptionsValueForIndex(value, enumOptions, emptyValue));
    const inline = Boolean(options && options.inline);
    return jsxRuntime.jsx(Form__default["default"].Group, {
      className: 'mb-0',
      children: Array.isArray(enumOptions) && enumOptions.map((option, index) => {
        const itemDisabled = Array.isArray(enumDisabled) && enumDisabled.indexOf(option.value) !== -1;
        const checked = utils.enumOptionsIsSelected(option.value, value);
        const radio = jsxRuntime.jsx(Form__default["default"].Check, {
          inline: inline,
          label: option.label,
          id: utils.optionId(id, index),
          name: id,
          type: 'radio',
          disabled: disabled || itemDisabled || readonly,
          checked: checked,
          required: required,
          value: String(index),
          onChange: _onChange,
          onBlur: _onBlur,
          onFocus: _onFocus,
          "aria-describedby": utils.ariaDescribedByIds(id)
        }, index);
        return radio;
      })
    });
  }

  function RangeWidget(props) {
    const {
      value,
      label,
      hideLabel,
      options,
      registry
    } = props;
    const BaseInputTemplate = utils.getTemplate('BaseInputTemplate', registry, options);
    return jsxRuntime.jsx(BaseInputTemplate, {
      ...props,
      extraProps: {
        label: utils.labelValue(label || undefined, hideLabel)
      },
      children: jsxRuntime.jsx("span", {
        className: 'range-view',
        children: value
      })
    });
  }

  function SelectWidget({
    schema,
    id,
    options,
    required,
    disabled,
    readonly,
    value,
    multiple,
    autofocus,
    onChange,
    onBlur,
    onFocus,
    placeholder,
    rawErrors = []
  }) {
    const {
      enumOptions,
      enumDisabled,
      emptyValue: optEmptyValue
    } = options;
    const emptyValue = multiple ? [] : '';
    function getValue(event, multiple) {
      if (multiple) {
        return [].slice.call(event.target.options).filter(o => o.selected).map(o => o.value);
      } else {
        return event.target.value;
      }
    }
    const selectedIndexes = utils.enumOptionsIndexForValue(value, enumOptions, multiple);
    return jsxRuntime.jsxs(Form__default["default"].Control, {
      as: 'select',
      bsPrefix: 'custom-select',
      id: id,
      name: id,
      value: typeof selectedIndexes === 'undefined' ? emptyValue : selectedIndexes,
      required: required,
      multiple: multiple,
      disabled: disabled || readonly,
      autoFocus: autofocus,
      className: rawErrors.length > 0 ? 'is-invalid' : '',
      onBlur: onBlur && (event => {
        const newValue = getValue(event, multiple);
        onBlur(id, utils.enumOptionsValueForIndex(newValue, enumOptions, optEmptyValue));
      }),
      onFocus: onFocus && (event => {
        const newValue = getValue(event, multiple);
        onFocus(id, utils.enumOptionsValueForIndex(newValue, enumOptions, optEmptyValue));
      }),
      onChange: event => {
        const newValue = getValue(event, multiple);
        onChange(utils.enumOptionsValueForIndex(newValue, enumOptions, optEmptyValue));
      },
      "aria-describedby": utils.ariaDescribedByIds(id),
      children: [!multiple && schema.default === undefined && jsxRuntime.jsx("option", {
        value: '',
        children: placeholder
      }), enumOptions.map(({
        value,
        label
      }, i) => {
        const disabled = Array.isArray(enumDisabled) && enumDisabled.indexOf(value) != -1;
        return jsxRuntime.jsx("option", {
          id: label,
          value: String(i),
          disabled: disabled,
          children: label
        }, i);
      })]
    });
  }

  function TextareaWidget({
    id,
    placeholder,
    value,
    required,
    disabled,
    autofocus,
    readonly,
    onBlur,
    onFocus,
    onChange,
    options
  }) {
    const _onChange = ({
      target: {
        value
      }
    }) => onChange(value === '' ? options.emptyValue : value);
    const _onBlur = ({
      target: {
        value
      }
    }) => onBlur(id, value);
    const _onFocus = ({
      target: {
        value
      }
    }) => onFocus(id, value);
    return jsxRuntime.jsx(InputGroup__default["default"], {
      children: jsxRuntime.jsx(FormControl__default["default"], {
        id: id,
        name: id,
        as: 'textarea',
        placeholder: placeholder,
        disabled: disabled,
        readOnly: readonly,
        value: value,
        required: required,
        autoFocus: autofocus,
        rows: options.rows || 5,
        onChange: _onChange,
        onBlur: _onBlur,
        onFocus: _onFocus,
        "aria-describedby": utils.ariaDescribedByIds(id)
      })
    });
  }

  function generateWidgets() {
    return {
      CheckboxWidget,
      CheckboxesWidget,
      RadioWidget,
      RangeWidget,
      SelectWidget,
      TextareaWidget
    };
  }
  var Widgets = /*#__PURE__*/generateWidgets();

  function generateTheme() {
    return {
      templates: generateTemplates(),
      widgets: generateWidgets()
    };
  }
  var Theme = /*#__PURE__*/generateTheme();

  function generateForm() {
    return core.withTheme(generateTheme());
  }
  var Form = /*#__PURE__*/generateForm();

  exports.Form = Form;
  exports.Templates = Templates;
  exports.Theme = Theme;
  exports.Widgets = Widgets;
  exports["default"] = Form;
  exports.generateForm = generateForm;
  exports.generateTemplates = generateTemplates;
  exports.generateTheme = generateTheme;
  exports.generateWidgets = generateWidgets;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=bootstrap-4.umd.development.js.map
